/**********************************************************************************************
 * Program Name:  Acme Filters
 *
 * Module Name:   Acme Filters.h
 *
 * Description:   Header file for ASC to Mac.c.
 *
 * Author:        Eric V. Curtis
 *
 * History:
 *        v1.0    08-Feb-1995  Created.
 **********************************************************************************************/

#ifndef ACME_FILTERS_H_
#define ACME_FILTERS_H_

/************ D E F I N E D   C O N S T A N T S   &   M A C R O S ******************************/

#define	kBaseResID		128
#define	kVersion		"\pVersion 2.3.0"
#define	kDate			"\p02-Feb-1996"

#define kTempFileName	"\p\004\031\137"	// 04/25/95 ;-)

#define	kAppleMenuID	kBaseResID
#define	kFileMenuID		kBaseResID+1
#define	kEditMenuID		kBaseResID+2

#define kSystemSeven	0x0700

#define	kAboutItem		1

#define	kUndoItem		1
#define	kCutItem		3
#define	kCopyItem		4
#define	kPasteItem		5
#define	kClearItem		6

#define kAboutBoxDlog	kBaseResID
#define kProgressDlog	kBaseResID+1
#define kDefaultDlog	kBaseResID+2

#define kMoveToFront	(WindowPtr)-1
#define kProgBarItem	1
#define kFileNameItem	3
#define kRemainItem		5
#define kSpinItem		6
#define kFilterNameItem	8

#define	kInset			12
#define kMaxName		27

#define kIconHeight		16
#define kIconSpace		2

#define kStartTimeOut	3
#define kAboutTimeOut	5
#define kEllipsis		''
#define kCursorType		'CURS'
#define kPrefType		'Pref'

#define	kAnyType		'****'
#define	kTEXTType		'TEXT'
#define	kWNCreator		'nX^n'	// WriteNow 4.0 text file with no line breaks
#define	kBufSize		2048

#define	kDivider		2

#define kNil			0x00
#define kCR				0x0d
#define kLF				0x0a
#define kFF				0x0c
#define kTab			0x09
#define kSpace			0x20

#define kEnter			0x03
#define kReturn			0x0d
#define kEscape			0x1b
#define kPeriod			0x2e



/************ T Y P E D E F S *****************************************************************/

enum { eCreate, eFileName, eRemainPercent, eDelete };

enum { kASCToMac = 1, kDeleteRF, kFindOriginal, kRot13, kTab2Space, kTouch, kTypeCreator,
		divider1, kPrefsItem, divider2, kQuitItem };



/************ G L O B A L   V A R I A B L E S *************************************************/

extern Str32		gAppName;
extern char			gConversionType;
extern Boolean		gQuit, gAutoQuit;
extern DialogPtr	gProgressDlog;
extern Boolean		gFromMenu;
extern Boolean		gCancelReq;



/************ F U N C T I O N   P R O T O T Y P E S *******************************************/

void	main( void );
void	GetOurProcessInfo( void );
void	SetupMenuBar( void );
void	HandleEvent( EventRecord *event );
void	HandleKeyDown( EventRecord *event );
void	HandleMouseDown( EventRecord *event );
void	HandleMenuChoice( long choice );
void	HandleAppleMenu( short item );
void	HandleFileMenu( short item );

OSErr	GetFileSpec( FSSpec *file, OSType type );
FILE	*FSfopen( FSSpec *spec, char *mode );
void	TickleParentDir( FSSpec *file );
OSType	GetFileType( FSSpec *file );

void	AboutBox( short hangTime );
pascal Boolean	AboutBoxDlgFltr( DialogPtr dialog, EventRecord *event, short *item );
short	CenterString( Rect *rect, Str255 string );
Boolean	pstrcat( Str255 s1, Str255 s2 );
void	pstrcpy( Str255 dst, Str255 src );

Boolean	Cancel( void );
void	SpinCursor( void );
void	ScrollIcon( void );
void	Progress( short what, short remain, Str255 name, short percent );
pascal void	FrameBar( WindowPtr dialog, short item );
void	LoadWindowPosition( WindowPtr window );
void	SaveWindowPosition( WindowPtr window );

OSErr	ChooseDefault( Boolean save );
pascal Boolean	ChooseDefaultDlgFltr( DialogPtr dialog, EventRecord *event, short *item );
char	LoadPreferred( void );
void	SavePreferred( char pref );
Boolean	SpecialKeyDown( unsigned short key );

#endif
