/************ I N C L U D E   F I L E S *******************************************************/

#include <stdio.h>

#include "Acme Filters.h"
#include "Delete RF.h"



/**********************************************************************************************
 * Function Name:  DeleteRF
 *
 * Description:    Delete the resource fork of a file.
 *
 * Parameters:     iFile - file spec of a file.
 *
 * Return Value:   None.
 **********************************************************************************************/
void	DeleteRF( FSSpec *iFile )
{
	short		refNum;
	HFileParam	iInfo;
	
	gCancelReq |= Cancel();
	ScrollIcon();
	
	// remember the file's information
	iInfo.ioNamePtr   = iFile->name;
	iInfo.ioVRefNum   = iFile->vRefNum;
	iInfo.ioDirID     = iFile->parID;
	iInfo.ioFDirIndex = 0;
	PBHGetFInfo( (HParmBlkPtr)&iInfo, false );
	
	// open the file's resource fork, set the length to zero, and close the file
	refNum = FSpOpenResFile( iFile, fsRdWrPerm );
	SetEOF( refNum, 0L );
	CloseResFile( refNum );
	
	// restore the file's information
	iInfo.ioNamePtr   = iFile->name;
	iInfo.ioVRefNum   = iFile->vRefNum;
	iInfo.ioDirID     = iFile->parID;
	iInfo.ioFDirIndex = 0;
	PBHSetFInfo( (HParmBlkPtr)&iInfo, false );
	PBFlushFile( (ParmBlkPtr)&iInfo, false );
	
	TickleParentDir( iFile );
}
