/************ I N C L U D E   F I L E S *******************************************************/

#include <stdio.h>

#include "Acme Filters.h"
#include "Rot 13.h"



/**********************************************************************************************
 * Function Name:  Rot13
 *
 * Description:    rot13 a file.
 *
 * Parameters:     iFile - file spec of a file.
 *
 * Return Value:   None.
 **********************************************************************************************/
void	Rot13( FSSpec *iFile )
{
	FILE	*iFp, *oFp;
	char	iBuf[kBufSize];
	char	*c, cc;
	FSSpec	oFile;
	FInfo	iInfo, oInfo;
	
	// create and open the output file
	FSMakeFSSpec( iFile->vRefNum, iFile->parID, iFile->name, &oFile );
	pstrcpy( oFile.name, kTempFileName );	// use a temporary name
	oFp = FSfopen( &oFile, "wb" );
	
	// set the output file's type and creator
	FSpGetFInfo( iFile, &iInfo );
	FSpGetFInfo( &oFile, &oInfo );
	oInfo.fdType = iInfo.fdType;
	oInfo.fdCreator = iInfo.fdCreator;
	FSpSetFInfo( &oFile, &oInfo );
	
	// filter the input file
	if ( iFp = FSfopen( iFile, "rb" ) )
	{
		while ( fgets( iBuf, kBufSize-1, iFp ) != nil )
		{
			gCancelReq |= Cancel();
			ScrollIcon();
			c = iBuf;
			while ( cc = *c )
			{
				// convert the character to uppercase
				if ( (cc >= 'a') && (cc <= 'z') )
				{
					cc = cc - 'a' + 'A';
				}
				
				// do the rotation
				if ( (cc >= 'A') && (cc <= 'M') )
				{
					*c += 13;
				}
				else if ( (cc >= 'N') && (cc <= 'Z') )
				{
					*c -= 13;
				}
				
				fputc( *c, oFp );
				c++;
			}
		}
	}
	
	// close the files
	if ( iFp ) fclose( iFp );
	if ( oFp ) fclose( oFp );
	
	// swap the contents of the two files and delete the copy
	FSpExchangeFiles( &oFile, iFile );
	FSpDelete( &oFile );
	
	TickleParentDir( &oFile );
}
