/**********************************************************************
 *	This file contains the bulk of the program.  All of the dialog box
 *	stuff is performed in this file.
 **********************************************************************/

#include	"Creator Changer.h"
#include	"Creator Changer.dialog.h"
#include	"GetFileIcon.h"


/**********************************************************************
 *	Function Open_DLOG(), this function is a general function for 
 *	opening all of the Dialog boxes in the program.
 **********************************************************************/

void Open_DLOG(Dialog_Info *the)
	{

	Handle				item_handle;
	static UserItemUPP	proc_for_draw_Chng_dialog=NIL_PTR;
	static UserItemUPP	proc_for_draw_Abot_dialog=NIL_PTR;
	File_Union			temp;
	
	if(proc_for_draw_Chng_dialog==NIL_PTR) proc_for_draw_Chng_dialog=NewUserItemProc(Draw_Chng_Dialog);
	if(proc_for_draw_Abot_dialog==NIL_PTR) proc_for_draw_Abot_dialog=NewUserItemProc(Draw_Abot_Dialog);
		
	the->dialog=GetNewDialog(the->dlog_id, the->storage, IN_FRONT);
	Dialog_Opened=YES;
	Maintain_Menu_Items(FrontWindow());
	
	if(the->dialog==Chng.dialog)
		{
		Make_Pop_Up_Menu(the->menu_id, the->pref_type, the->num_items);
		Set_Dialog_Proc((Handle)proc_for_draw_Chng_dialog, Chng.dialog, CHNG_DLOG_UI);
		if(!Multiple_Files)
			{
			Set_Type_Text(&F_Type, File_Info.fdType);
			Set_Type_Text(&C_Type, File_Info.fdCreator);
			}
		}
	else if(the->dialog==About.dialog) Set_Dialog_Proc((Handle)proc_for_draw_Abot_dialog, About.dialog, ABOUT_DLOG_UI);
	else if(the->dialog==Pref.dialog)
		{
		Get_Dialog_Item_Hndl(the->dialog, PREF_POPUP, &item_handle);
		Handle_Pref_Pop_Up_Menu(the, YES);
		}
	
	}



/**********************************************************************
 *	Function Switch_Chng_Dialog(), this function decides where events
 *	in the Change Dialog box should go.
 **********************************************************************/

void Switch_Chng_Dialog(Dialog_Info *the, short item_hit)
	{
	
	switch(item_hit)
		{
		case CHNG_OK:
			Handle_Chng_OK(the->dialog, &the->files, the->num_files, CHNG_CREATOR, CHNG_FILE);
			break;
		case CHNG_POP_UP:
			Handle_Pt_Pop_Up(the->dialog, CHNG_POP_UP, CHNG_CREATOR, CHNG_FILE, NO);
			break;
		case CHNG_CANCEL:
			CloseDialog(the->dialog);
			Done_With_Dialog=YES;
			Dialog_Opened=NO;
			Maintain_Menu_Items(FrontWindow());
			break;
		case CHNG_MKLK:
			Handle_Make_Like(the->dialog, CHNG_FILE, CHNG_CREATOR, NIL_PTR);
			break;
		case CHNG_CRNT_CREATOR:
			if(!Multiple_Files) Set_DLOG_Text_Item(the->dialog, CHNG_CREATOR, C_Type.TEXT);
			break;
		case CHNG_CRNT_TYPE:
			if(!Multiple_Files) Set_DLOG_Text_Item(the->dialog, CHNG_FILE, F_Type.TEXT);
			break;
		default:
			break;
		}
		
	}


/**********************************************************************
 *	Function Switch_Pt_Dialog(), this function decides where events
 *	in the Edit DITL should go.  This is part of the Preference Dialog.
 **********************************************************************/

void Switch_Pt_Dialog(Dialog_Info *the, short item_hit)
	{
	
	short			os=the->num_items;
	
	switch(item_hit-os)
		{
		case P_PT_PM:
			Handle_Pt_Pop_Up(the->dialog, os+P_PT_PM, os+P_PT_CT, os+P_PT_FT, os+P_PT_DS);
			break;
		case P_PT_ADD:
			Handle_Pt_Add_Item(the->dialog, os+P_PT_CT, os+P_PT_FT, os+P_PT_DS);
			break;
		case P_PT_DEL:
			Handle_Pt_Del_Item();
			break;
		case P_PT_GFL:
			Handle_Make_Like(the->dialog, os+P_PT_FT, os+P_PT_CT, NIL_PTR);
			break;
		case P_PT_DON:
			CloseDialog(the->dialog);
			Dialog_Opened=NO;
			the->menu_id=NIL_PTR;
			Maintain_Menu_Items(FrontWindow());
			break;
		default:
			break;
		}
		
	}


/**********************************************************************
 *	Function Switch_Ac_Dialog(), this function decides where events
 *	in the Auto DITL should go.  This is part of the Preference Dialog.
 **********************************************************************/

void Switch_Ac_Dialog(Dialog_Info *the, short item_hit)
	{
	
	short			os=the->num_items;
	
	switch(item_hit-os)
		{
		case P_AC_POPM:
			Handle_Ac_Pop_Up(the->dialog, os+P_AC_POPM, os+P_AC_CHFT, os+P_AC_CTCT, os+P_AC_CTFT);
			break;
		case P_AC_ADD:
			Handle_Ac_Add_Item(the->dialog, os+P_AC_CHFT, os+P_AC_CTCT, os+P_AC_CTFT);
			break;
		case P_AC_DEL:
			Handle_Ac_Del_Item();
			break;
		case P_AC_GFL:
			Handle_Make_Like(the->dialog, os+P_AC_CTFT, os+P_AC_CTCT, os+P_AC_CHFT);
			break;
		case P_AC_DON:
			CloseDialog(the->dialog);
			Dialog_Opened=NO;
			the->menu_id=NIL_PTR;
			Maintain_Menu_Items(FrontWindow());
			break;
		default:
			break;
		}
		
	}


/**********************************************************************
 *	Function Switch_Abot_Dialog(), this function decides where events
 *	in the About Dialog should go. 
 **********************************************************************/

void Switch_Abot_Dialog(Dialog_Info *the, short item_hit)
	{
	
	switch(item_hit)
		{
		case ABOUT_OK:
			CloseDialog(the->dialog);
			Dialog_Opened=NO;
			Maintain_Menu_Items(FrontWindow());
			break;
		default:
			break;
		}
		
	}


/**********************************************************************
 *	Function Switch_Pref_Dialog(), this function decides where events
 *	in the Preference Dialog box should go.
 **********************************************************************/

void Switch_Pref_Dialog(Dialog_Info *the, short item_hit)
	{
	
	switch(item_hit)
		{
		case PREF_POPUP:
			Handle_Pref_Pop_Up_Menu(the, NO);
			break;
		default:
			Handle_Pref_DITL_Item(the, item_hit);
			break;
		}
		
	}



/**********************************************************************
 *	Function Switch_Gnrl_Dialog(), this function decides where events
 *	in the General DITL should go.  This is part of the Preference Dialog.
 **********************************************************************/

void Switch_Gnrl_Dialog(Dialog_Info *the, short item_hit)
	{
	
	short			os=the->num_items;
	global_prefs	**rsrc_handle;
	
	switch(item_hit-os)
		{
		case P_GN_OKAC:
			UseResFile(CreatorChangerPref);
				rsrc_handle=(global_prefs **)GetResource(PREF_GL, 128);
				(**rsrc_handle).AutoChange=Handle_Check_Item(the->dialog, os+P_GN_OKAC);
				ChangedResource((Handle)rsrc_handle);
				UpdateResFile(CreatorChangerPref);
			UseResFile(CreatorChangerApp);
			break;
		case P_GN_QADD:
			UseResFile(CreatorChangerPref);
				rsrc_handle=(global_prefs **)GetResource(PREF_GL, 128);
				(**rsrc_handle).DragQuit=Handle_Check_Item(the->dialog, os+P_GN_QADD);
				ChangedResource((Handle)rsrc_handle);
				UpdateResFile(CreatorChangerPref);
			UseResFile(CreatorChangerApp);
			break;
		case P_GN_OKBT:
			CloseDialog(the->dialog);
			Dialog_Opened=NO;
			the->menu_id=NIL_PTR;
			Maintain_Menu_Items(FrontWindow());
			break;
		}
		
	}


/**********************************************************************
 *	Function Handle_Chng_OK(), this function changes the file and 
 *	creator types of the file(s) opened.
 **********************************************************************/
 
void Handle_Chng_OK(DialogPtr the_dialog, AEDescList *the_files, long num_of_files, short creator, short file)
 	{
 	
 	short	register	i;
 	short 				temp;
 	AEKeyword			key_word;
	DescType			the_type;
	Size				the_size;
 	
 	temp=Check_Data(the_dialog, file, NO)+Check_Data(the_dialog, creator, NO);
 	
	if(temp<TYPE_LEN)
		{
		for(i=1;i<=num_of_files;i++)
			{
			if(Multiple_Files)
				{
				AEGetNthPtr(the_files, i, typeFSS, &key_word, &the_type, &The_File_Spec, sizeof(The_File_Spec), &the_size);
				FSpGetFInfo(&The_File_Spec, &File_Info);
				}
			Set_Type_Long(NIL_PTR, &File_Info.fdType,    the_dialog, file);
			Set_Type_Long(NIL_PTR, &File_Info.fdCreator, the_dialog, creator);
			FSpSetFInfo(&The_File_Spec, &File_Info);
			}
		Force_Finder_Update(&The_File_Spec);
		if(Multiple_Files) AEDisposeDesc(the_files);
		CloseDialog(the_dialog);
		Done_With_Dialog=YES;
		Dialog_Opened=NO;
		Maintain_Menu_Items(the_dialog);
		}
	else Do_Error(Types_Error_1, EMPTY_STR, Types_Error_2, EMPTY_STR);
	
	}



/**********************************************************************
 *	Function Set_Type_Long(), this function sets the file type of the
 *	specified file.  (converts a string in an edit field to an 
 *	unsigned decimal equivalent).
 **********************************************************************/

void Set_Type_Long(Str4 in_string, OSType *out_long,  DialogPtr the_dialog, short ID)
	{
	
	short		i;
	File_Union	file_type;
	
	if(the_dialog!=NIL_PTR) Get_Dialog_Text(in_string, the_dialog, ID);
	for(i=0;i<=TYPE_LEN;i++) file_type.TEXT[i]=in_string[i+1];
	
	*out_long=file_type.LONG;
	
	}



/**********************************************************************
 *	Function Set_Type_Text(), this function sets the text for the file
 *	and creator types given an usigned decimal file / creator type.
 **********************************************************************/

void Set_Type_Text(File_Union *the_type, OSType the_long_type)
	{
	
	short		i;
	File_Union	temp;
	
	the_type->TEXT[0]=TYPE_LEN;
	temp.LONG=the_long_type;
	for(i=0;i<=TYPE_LEN;i++) the_type->TEXT[i+1]=temp.TEXT[i];
	
	}



/**********************************************************************
 *	Function Handle_Make_Like(), this function picks a file to use as
 *	a template.
 **********************************************************************/

void Handle_Make_Like(DialogPtr the_dialog, short file, short creator, short from_file)
	{
	
	File_Union	f_type, c_type;
	FSSpec		ml_file_spec;
	FInfo		ml_file_info;
	
	if(Pick_File(&ml_file_spec, &ml_file_info, FALSE))
		{
		Set_Type_Text(&f_type, ml_file_info.fdType);
		Set_Type_Text(&c_type, ml_file_info.fdCreator);
		
		if(from_file) Set_DLOG_Text_Item(the_dialog, from_file, f_type.TEXT);
		Set_DLOG_Text_Item(the_dialog, file,    f_type.TEXT);
		Set_DLOG_Text_Item(the_dialog, creator, c_type.TEXT);
		}
	PT_Item_To_Edit=AC_Item_To_Edit=0;
	
	}



/**********************************************************************
 *	Function Handle_Pt_Add_Item(), this function actually does the adding
 *	of the items to the preferences file.
 **********************************************************************/

void Handle_Pt_Add_Item(DialogPtr the_dialog, short creator, short file, short description)
	{
	
	short		temp;
	pref_types	**rsrc_handle;
	
	temp=Check_Data(the_dialog, file, NO)+Check_Data(the_dialog, creator, NO)+Check_Data(the_dialog, description, YES);
	
	if(temp<TYPE_LEN)
		{
		UseResFile(CreatorChangerPref);
			rsrc_handle=(pref_types **)NewHandle(sizeof(pref_types));
			
			Get_Dialog_Text((**rsrc_handle).Description, the_dialog, description);
			Get_Dialog_Text((**rsrc_handle).CreatorType, the_dialog, creator);
			Get_Dialog_Text((**rsrc_handle).FileType, the_dialog, file);
			
			AddResource((Handle)rsrc_handle, PREF_PT, Chng.num_items==0 ? Strt_Rsrc : The_pt_Type[Chng.num_items]+1, (**rsrc_handle).Description);
			ChangedResource((Handle)rsrc_handle);
			UpdateResFile(CreatorChangerPref);
			Chng.num_items=Edit.num_items=CountResources(PREF_PT);
			ReleaseResource((Handle)rsrc_handle);
		UseResFile(CreatorChangerApp);
		Make_Pop_Up_Menu(PREF_TYPES_ID, PREF_PT, Chng.num_items);
		PT_Item_To_Edit=0;
		}
	else if(temp<=TYPE_LEN+TYPE_LEN+1)	Do_Error(Types_Error_1, EMPTY_STR, Types_Error_2, EMPTY_STR);
	else if(temp==DESC_LEN+2)			Do_Error(Descr_Error, EMPTY_STR, EMPTY_STR, EMPTY_STR);
	else								Do_Error(Types_Error_1, Descr_Error, EMPTY_STR, EMPTY_STR);
	
	}



/**********************************************************************
 *	Function Handle_Pt_Del_Item(), this function actually does the
 *	deleting of the item from the preferences file.
 **********************************************************************/

void Handle_Pt_Del_Item(void)
	{
	
	short		resource_number, i;
	pref_types	**rsrc_handle;
	
	if(PT_Item_To_Edit)
		{
		UseResFile(CreatorChangerPref);
			resource_number=The_pt_Type[PT_Item_To_Edit];
			rsrc_handle=(pref_types **)NewHandle(sizeof(pref_types));
			rsrc_handle=(pref_types **)GetResource(PREF_PT, resource_number);
			RmveResource((Handle)rsrc_handle);
			ReleaseResource((Handle)rsrc_handle);
			UpdateResFile(CreatorChangerPref);
			for(i=(resource_number+1);i<=The_pt_Type[Chng.num_items];i++)
				{
				rsrc_handle=(pref_types **)GetResource(PREF_PT, i);
				DetachResource((Handle)rsrc_handle);
				AddResource((Handle)rsrc_handle, PREF_PT, i-1, NIL_PTR);
				ChangedResource((Handle)rsrc_handle);
				ReleaseResource((Handle)rsrc_handle);
				
				rsrc_handle=(pref_types **)GetResource(PREF_PT, i);
				RmveResource((Handle)rsrc_handle);
				ChangedResource((Handle)rsrc_handle);
				ReleaseResource((Handle)rsrc_handle);
				}
			UpdateResFile(CreatorChangerPref);
			Chng.num_items=Edit.num_items=CountResources(PREF_PT);
		UseResFile(CreatorChangerApp);
		Make_Pop_Up_Menu(PREF_TYPES_ID, PREF_PT, Chng.num_items);
		PT_Item_To_Edit=0;
		}
	else Do_Error(Bad_Item_Error, EMPTY_STR, EMPTY_STR, EMPTY_STR);
		
	}



/**********************************************************************
 *	Function Handle_Ac_Add_Item(), this function actually does the adding
 *	of the items to the preferences file.
 **********************************************************************/

void Handle_Ac_Add_Item(DialogPtr the_dialog, short from_file_id, short to_creator_id, short to_file_id)
	{
	
	OSType		long_from_file;
	short		temp;
	auto_chng	**rsrc_handle;
	Str4		types[100];
				
	temp=Check_Data(the_dialog, from_file_id, NO)+Check_Data(the_dialog, to_creator_id, NO)+Check_Data(the_dialog, to_file_id, NO);
	
	if(temp<TYPE_LEN)
		{
		Get_Types_From_Prefs(types);
		Set_Type_Long(NIL_PTR, &long_from_file, the_dialog, from_file_id);
		if(Check_File_Type(types, long_from_file)) Do_Error(Bad_CF_Type_1, Bad_CF_Type_2, Bad_CF_Type_3, Bad_CF_Type_4);
		else
			{
			rsrc_handle=(auto_chng **)NewHandle(sizeof(auto_chng));
			
			Get_Dialog_Text((**rsrc_handle).FromFile, the_dialog, from_file_id);
			Get_Dialog_Text((**rsrc_handle).ToCreator, the_dialog, to_creator_id);
			Get_Dialog_Text((**rsrc_handle).ToFile, the_dialog, to_file_id);
			
			Make_Ac_Name((**rsrc_handle).Name, (**rsrc_handle).FromFile, (**rsrc_handle).ToCreator, (**rsrc_handle).ToFile);
			UseResFile(CreatorChangerPref);
				AddResource((Handle)rsrc_handle, PREF_AC, Auto.num_items==0 ? Strt_Rsrc : The_ac_Type[Auto.num_items]+1, (**rsrc_handle).Name);
				ChangedResource((Handle)rsrc_handle);
				UpdateResFile(CreatorChangerPref);
				Auto.num_items=CountResources(PREF_AC);
			UseResFile(CreatorChangerApp);
			ReleaseResource((Handle)rsrc_handle);
			}
		Make_Pop_Up_Menu(AUTO_CHANGE_ID, PREF_AC, Auto.num_items);
		AC_Item_To_Edit=0;
		}
	else Do_Error(Types_Error_1, EMPTY_STR, EMPTY_STR, EMPTY_STR);
	
	}



/**********************************************************************
 *	Function Make_Ac_Name(), this function makes the name
 *	which shows up in the pop-up menu for the auto change items.
 **********************************************************************/

void Make_Ac_Name(StringPtr name, StringPtr from_file, StringPtr to_creator, StringPtr to_file)
	{
	
	register short i;
	
	name[0]=16;
	for(i=1;i<=4;i++) name[i]=from_file[i];
	name[5]='-';
	name[6]='>';
	for(i=7;i<=10;i++) name[i]=to_creator[i-6];
	name[11]=',';
	name[12]=' ';
	for(i=13;i<=16;i++) name[i]=to_file[i-12];
	
	}


/**********************************************************************
 *	Function Handle_Ac_Del_Item(), this function deletes items 
 *	from the auto change item list.
 **********************************************************************/

void Handle_Ac_Del_Item(void)
	{
	
	short		resource_number, i;
	auto_chng	**rsrc_handle;
	
	if(AC_Item_To_Edit)
		{
		UseResFile(CreatorChangerPref);
			resource_number=The_ac_Type[AC_Item_To_Edit];
			rsrc_handle=(auto_chng **)NewHandle(sizeof(auto_chng));
			rsrc_handle=(auto_chng **)GetResource(PREF_AC, resource_number);
			RmveResource((Handle)rsrc_handle);
			ReleaseResource((Handle)rsrc_handle);
			UpdateResFile(CreatorChangerPref);
			for(i=(resource_number+1);i<=The_ac_Type[Auto.num_items];i++)
				{
				rsrc_handle=(auto_chng **)GetResource(PREF_AC, i);
				DetachResource((Handle)rsrc_handle);
				AddResource((Handle)rsrc_handle, PREF_AC, i-1, NIL_PTR);
				ChangedResource((Handle)rsrc_handle);
				ReleaseResource((Handle)rsrc_handle);
				
				rsrc_handle=(auto_chng **)GetResource(PREF_AC, i);
				RmveResource((Handle)rsrc_handle);
				ChangedResource((Handle)rsrc_handle);
				ReleaseResource((Handle)rsrc_handle);
				}
			UpdateResFile(CreatorChangerPref);
			Auto.num_items=CountResources(PREF_AC);
		UseResFile(CreatorChangerApp);
		Make_Pop_Up_Menu(AUTO_CHANGE_ID, PREF_AC, Auto.num_items);
		AC_Item_To_Edit=0;
		}
	else Do_Error(Bad_Item_Error, EMPTY_STR, EMPTY_STR, EMPTY_STR);
	
	}


/**********************************************************************
 *	Function Handle_Check_Item(), this function either checks or 
 *	unchecks a check box item.
 **********************************************************************/

Boolean Handle_Check_Item(DialogPtr the_dialog, short dialog_item)
	{
	
	Boolean	value;
	Handle		the_handle;
	
	Get_Dialog_Item_Hndl(the_dialog, dialog_item, &the_handle);
	value=GetCtlValue((ControlHandle)the_handle);
	
	if(value==TRUE)
		{
		SetCtlValue((ControlHandle)the_handle, FALSE);
		return(FALSE);
		}
	else if(value==FALSE)
		{
		SetCtlValue((ControlHandle)the_handle, TRUE);
		return(TRUE);
		}
	
	}


/**********************************************************************
 *	Function Draw_Default_Border(), this function draws the border
 *	around the item sent to it, that is within the specified dialog box
 **********************************************************************/

void Draw_Border(DialogPtr the_dialog, short the_item, short is_default)
	{
	
	short		diameter;
	Rect		item_rect;
	GrafPtr		old_port;
	
	GetPort(&old_port);
	SetPort(the_dialog);
	
	Get_Dialog_Item_Rect(the_dialog, the_item, &item_rect);
	if(is_default)
		{
		diameter=(item_rect.bottom-item_rect.top)/2+6;
		if(diameter<16) diameter=16;
		PenSize(3, 3);
		InsetRect(&item_rect, -4, -4);
		FrameRoundRect(&item_rect, diameter, diameter);
		}
	else
		{
		PenSize(1, 1);
		FrameRect(&item_rect);
		}
		
	SetPort(old_port);
	
	}



/**********************************************************************
 *	Function Draw_Chng_Crnt_Type(), this function handels what happens 
 *	if a key is pressed.
 **********************************************************************/
 
void Draw_Chng_Crnt_Type(DialogPtr the_dialog)
	{
	
	Rect	item_rect;
	GrafPtr	old_port;
	
	TextFont(systemFont);
	TextSize(12);
	TextFace(0);
	
	GetPort(&old_port);
	SetPort(the_dialog);
	
	Draw_Border(the_dialog, CHNG_CRNT_CREATOR, NO);
	Get_Dialog_Item_Rect(the_dialog, CHNG_CRNT_CREATOR, &item_rect);
	MoveTo(item_rect.left+4, item_rect.bottom-7);
	DrawString(C_Type.TEXT);
	
	Draw_Border(the_dialog, CHNG_CRNT_TYPE, NO);
	Get_Dialog_Item_Rect(the_dialog, CHNG_CRNT_TYPE, &item_rect);
	MoveTo(item_rect.left+4, item_rect.bottom-7);
	DrawString(F_Type.TEXT);
	
	SetPort(old_port);
	
	}



/**********************************************************************
 *	Function Check_Data(), this function checks the type entered
 *	by the user.  If there are more than 4 charachters than there is 
 *	an error, and if there is no data entered in there is an error.
 **********************************************************************/

short Check_Data(DialogPtr the_dialog, short ID, short is_desc)
	{
	
	Str255		the_error;
	short		the_type_len, len;
	Str32		item_text;
	
	Get_Dialog_Text(item_text, the_dialog, ID);
	len=item_text[0];
	if(is_desc) the_type_len=DESC_LEN;
	else the_type_len=TYPE_LEN;
	if(len!=the_type_len && the_type_len==TYPE_LEN) return(TYPE_LEN);
	else if((len>the_type_len && the_type_len==DESC_LEN) || len==0) return(DESC_LEN);
	else return(GOOD);
	
	}



/**********************************************************************
 *	Function Set_DLOG_Text_Item(), this function sets text boxes in the
 *	selected dialog to the text which is sent to it.
 **********************************************************************/

void Set_DLOG_Text_Item(DialogPtr the_dialog, short ID, StringPtr the_text)
	{
	
	Handle		the_handle;
	
	Get_Dialog_Item_Hndl(the_dialog, ID, &the_handle);
	SetIText(the_handle, the_text);
	
	}



/**********************************************************************
 *	Function Draw_Chng_Dialog(), this function draws the objects in the
 *	Change dialog box.
 **********************************************************************/

static pascal void Draw_Chng_Dialog(DialogPtr the_dialog, short blank_item)
	{
	
	Rect		item_rect;
	GrafPtr		old_port;
	
	GetPort(&old_port);
	SetPort(the_dialog);
	
	if(!Multiple_Files)
		{
		Get_Dialog_Item_Rect(the_dialog, CHNG_ICON, &item_rect);
		PlotIconSuite(&item_rect, 0, 0, The_Icons);
		Draw_Chng_Crnt_Type(the_dialog);
		}
	Draw_Border(the_dialog, CHNG_OK, YES);
	
	SetPort(old_port);

	}
	


/**********************************************************************
 *	Function Draw_Abot_Dialog(), this function draws the objects in the
 *	About dialog box.
 **********************************************************************/

static pascal void Draw_Abot_Dialog(DialogPtr the_dialog, short blank_item)
	{
	
	GrafPtr		old_port;
	
	GetPort(&old_port);
	SetPort(the_dialog);
	
	Draw_Border(the_dialog, ABOUT_OK, YES);
	
	SetPort(old_port);
	
	}



/**********************************************************************
 *	Function 
 **********************************************************************/

static pascal void Draw_Pref_Dialog(DialogPtr the_dialog, short blank_item)
	{
		
	Draw_Pref_Border(the_dialog, NIL_PTR);
	if(Pref.menu_id==P_EPTYPE_ITEM) Draw_Pref_Pt(the_dialog, NIL_PTR);
	if(Pref.menu_id==P_EATYPE_ITEM) Draw_Pref_Ac(the_dialog, NIL_PTR);
	if(Pref.menu_id==P_GENERL_ITEM) Draw_Pref_Gnrl(the_dialog, NIL_PTR);
	
	}



/**********************************************************************
 *	Function Draw_Pref_Pt(), this function draws the objects in the
 *	Preference dialog box with respecto the Preferend Types DITL.
 **********************************************************************/

static pascal void Draw_Pref_Pt(DialogPtr the_dialog, short blank_item)
	{
	
	short		os=Pref.num_items;
	GrafPtr		old_port;
	
	GetPort(&old_port);
	SetPort(the_dialog);
	
	Draw_Border(the_dialog, os+P_PT_DON, YES);
	
	SetPort(old_port);
	
	}



/**********************************************************************
 *	Function Draw_Pref_Ac(), this function draws the objects in the
 *	Preference dialog box with respecto the Automatic Types DITL.
 **********************************************************************/

static pascal void Draw_Pref_Ac(DialogPtr the_dialog, short blank_item)
	{
	
	short		os=Pref.num_items;
	GrafPtr		old_port;
	
	GetPort(&old_port);
	SetPort(the_dialog);
	
	Draw_Border(the_dialog, os+P_AC_DON, YES);
	
	SetPort(old_port);
	
	}



/**********************************************************************
 *	Function Draw_Pref_Gnrl(), this function draws the objects in the
 *	Preference dialog box with respecto the General DITL.
 **********************************************************************/

static pascal void Draw_Pref_Gnrl(DialogPtr the_dialog, short blank_item)
	{
	
	Handle		item_handle;
	short		os=Pref.num_items;
	GrafPtr		old_port;
	
	GetPort(&old_port);
	SetPort(the_dialog);
		
	Get_Dialog_Item_Hndl(the_dialog, os+P_GN_OKAC, &item_handle);
	SetCtlValue((ControlHandle)item_handle, (**Global).AutoChange);
	Get_Dialog_Item_Hndl(the_dialog, os+P_GN_QADD, &item_handle);
	SetCtlValue((ControlHandle)item_handle, (**Global).DragQuit);
	Draw_Border(the_dialog, os+P_GN_OKBT, YES);
	
	SetPort(old_port);
	
	}



/**********************************************************************
 *	Function Draw_Pref_Border(), this function  draws the box which 
 *	is shown in the Preference dialog.
 **********************************************************************/

static pascal void Draw_Pref_Border(DialogPtr the_dialog, short blank_item)
	{
	
	short		i;
	Rect		item_rect;
	GrafPtr		old_port;
	
	GetPort(&old_port);
	SetPort(the_dialog);
	
	PenSize(1, 1);
	for(i=2;i<=6;i++)
		{
		Get_Dialog_Item_Rect(the_dialog, i, &item_rect);
		FrameRect(&item_rect);
		}
		
	SetPort(old_port);
	
	}



/**********************************************************************
 *	Function Handle_Pref_Set_Up_DLOG(), this function  appends the new 
 *	dialog items to the main preference dialog.
 **********************************************************************/

void Handle_Pref_Set_Up_DLOG(DialogPtr the_dialog, short the_ditl, short *ditl_count)
	{
	
	Handle			ditl_handle;
	
	ditl_handle=GetResource( 'DITL', the_ditl);
	
	HLock(ditl_handle);
	AppendDITL(the_dialog, ditl_handle, overlayDITL);
	HUnlock(ditl_handle);
	ReleaseResource(ditl_handle);
	
	*ditl_count=CountDITL(the_dialog);
	
	}



/**********************************************************************
 *	Function Handle_Pref_Pop_Up_Menu(), this function updates  
 *	and sets up the pop-up menu which decides which dialog
 *	items are displayed.
 **********************************************************************/

void Handle_Pref_Pop_Up_Menu(Dialog_Info *the, short first_time)
	{
	
	Handle					item_handle;
	short					control_value, num_items;
	static UserItemUPP		proc_for_draw_Pref_dialog=NIL_PTR;
	
	if(proc_for_draw_Pref_dialog==NIL_PTR) proc_for_draw_Pref_dialog=NewUserItemProc(Draw_Pref_Dialog);
	
	Get_Dialog_Item_Hndl(the->dialog, PREF_POPUP, &item_handle);
	control_value=GetControlValue((ControlHandle)item_handle);
	if(the->menu_id!=control_value)
		{
		the->menu_id=control_value;
		if(!first_time) ShortenDITL(the->dialog, CountDITL(the->dialog)-PREF_MAX_ITEMS);
		Handle_Pref_Set_Up_DLOG(the->dialog, PREF_DLOG_ID+the->menu_id, &num_items);
		Set_Dialog_Proc((Handle)proc_for_draw_Pref_dialog, the->dialog, num_items);
		switch(control_value)
			{
			case P_EPTYPE_ITEM:
				Make_Pop_Up_Menu(Edit.menu_id, Edit.pref_type, Edit.num_items);
				break;
			case P_EATYPE_ITEM:
				Make_Pop_Up_Menu(Auto.menu_id, Auto.pref_type, Auto.num_items);
				break;
			}
		}
	
	}



/**********************************************************************
 *	Function Handle_Pref_DITL_Item(), this function ACTUALLY decides where to
 *	to direct an event if it wasn't for the main preference dialog items.
 **********************************************************************/

void Handle_Pref_DITL_Item(Dialog_Info *the, short item_hit)
	{
	
	switch(the->menu_id)
		{
		case P_EPTYPE_ITEM:
			Switch_Pt_Dialog(the, item_hit);
			break;
		case P_EATYPE_ITEM:
			Switch_Ac_Dialog(the, item_hit);
			break;
		case P_GENERL_ITEM:
			Switch_Gnrl_Dialog(the, item_hit);
			break;
		default:
			break;
		}
	
	}



/**********************************************************************
 *	Function Get_Dialog_Text), this function 
 **********************************************************************/

void Get_Dialog_Text(StringPtr the_string, DialogPtr the_dialog, short the_item)
	{
	
	Handle		item_handle;
	
	Get_Dialog_Item_Hndl(the_dialog, the_item, &item_handle);
	GetIText(item_handle, the_string);
	
	}



/**********************************************************************
 *	Function Set_Dialog_Proc(), this function 
 **********************************************************************/

void Set_Dialog_Proc(Handle the_proc, DialogPtr the_dialog, short the_item)
	{
	
	Handle		item_handle;
	short		item_type;
	Rect		item_rect;
	
	GetDItem(the_dialog, the_item, &item_type, &item_handle, &item_rect);
	SetDItem(the_dialog, the_item, item_type, the_proc, &item_rect);
	
	}



/**********************************************************************
 *	Function Get_Dialog_Item_Hndl(), this function 
 **********************************************************************/

void Get_Dialog_Item_Hndl(DialogPtr the_dialog, short the_item, Handle *the_handle)
	{
	
	short		item_type;
	Rect		item_rect;
	
	GetDItem(the_dialog, the_item, &item_type, the_handle, &item_rect);
	
	}



/**********************************************************************
 *	Function Get_Dialog_Item_Rect(), this function 
 **********************************************************************/

void Get_Dialog_Item_Rect(DialogPtr the_dialog, short the_item, Rect *the_rect)
	{
	
	Handle		item_handle;
	short		item_type;
	
	GetDItem(the_dialog, the_item, &item_type, &item_handle, the_rect);
	
	}



/**********************************************************************
 *	Function Get_Dialog_Item_In_Rect(), this function 
 **********************************************************************/

Boolean Get_Dialog_Item_In_Rect(DialogPtr the_dialog, short the_item, Point the_point)
	{
	
	Rect	item_rect;
	
	Get_Dialog_Item_Rect(the_dialog, the_item, &item_rect);
	if(PtInRect(the_point, &item_rect)) return(YES);
	return(NO);
	
	}
