
#define	strdup(string)	strcpy((char *)malloc(strlen(string)+1),string)

/* tidelib.h - external declarations for tidelib.c */

#define linelen 3000

/* Definition for PI (M. F.) */
#define	M_PI 3.1415927

/* Width of graph in ASCII graph mode */
#define TEXTWIDTH 73
/* Tstep adjustment for ASCII graph mode */
#define AGTSTEP 20
/* Tstep adjustment for banner mode */
#define BANTSTEP 10

/* These OSs don't have the nifty zoneinfo database that's needed
   to do global time zones, so fake it as best can.
*/
#if defined(OS2) || defined(AIX) || defined(__hpux)
#define BROKEN_ZONEINFO
#endif
#if defined(sgi) && (defined(SVR4) || defined(__svr4__))
#define BROKEN_ZONEINFO
#endif

enum tideerr {BADCOLORSPEC, WANTMOREARGS, CONFIGFAIL,
  BADINTEGER, BADFLOAT, BADHHMM, STRETCHTOOSMALL, STRETCHTOOBIG,
  BADTIMESTAMP, MISSINGYEAR, BADGEOMETRY, CANTOPENDISPLAY, CANTOPENFILE,
  OFFSETSTEXTONLY};

extern void sigabort ();  /* Leave out parms for portability */
extern int hhmm2seconds (char *hhmm);
extern void load_data (void);
extern void check_epoch (void);
extern time_t parse_time_string (char *time_string);
extern int yearoftimet (time_t t);
extern void happy_new_year (int new_year);
extern double time2tide (time_t t);
extern void do_timestamp (char buf[13], struct tm *t);
extern struct tm *tmtime (time_t t);
extern int update_high_tide (void);
extern void list_tides (void);
extern void tide2ascii (void);
extern void tide2ppm (char *);
extern time_t prev_hour (time_t);
extern time_t prev_day (time_t);
extern time_t increment_day (time_t);
extern void change_time_zone (char *);
extern void barf (enum tideerr);
extern void do_calendar ();
extern void do_banner ();

#define _Gestalt 0xA1AD
#define TrapMask 0x0800