(* !macuseful.sml *)
(* 21Oct95  e     *)

(* some useful command lines *)
(*
 * change <home> to the name of the volume or path for your mosmlFolder

:mosml.image -stdlib <home>:mosml:src:mosmllib: -P none
:mosml.image -stdlib <home>:mosml:src:mosmllib: -P full

:mosmllexe :src:lex:Scanner.lex
:mosmllexe :src:compiler:Lexer.lex
:mosmllexe :src:toolssrc:Deplex.lex

*)

(* some useful make commands...
 *
 * change "testtop.image" to your image name
 *  or to "mosml.image" to replace the current version; DANGEROUS!
 *)

(* ********************************** *)

moolevel := 2;

(* to compile the toplevel mosml image and the lexer *)

let val base = "<home>" ^ ":mosml:src:"
in
  make "none" (base ^ "mosmllib") [] (base ^ "mosmllib");
  make "none" (base ^ "mosmllib") [] (base ^ "compiler");
  make "none" (base ^ "mosmllib") [(base ^ "compiler")] (base ^ "toolssrc");
  make "none" (base ^ "mosmllib") [(base ^ "lex"),(base ^ "compiler")] (base ^ "lex")
end;

(* to build the toplevel mosml image *)

let val base = "<home>" ^ ":mosml:src:"
in
  chDir base; chDir "::";
  link "testtop.image"
       (true,true) (* -g -noheader *)
       "lorder" (base ^ "mosmllib") [(base ^ "compiler"),(base ^ "toolssrc")]
       ["Maine.uo"]
end;

(* to build the lexer *)

let val base = "<home>" ^ ":mosml:src:"
in
  chDir base; chDir "::";
  link "mosmllex"
       (true,true) (* -g -noheader *)
       "lorder" (base ^ "mosmllib") [(base ^ "lex"),(base ^ "compiler")]
       ["Mainlex.uo"]
end;

(* another way to build the toplevel mosml image *)

let val base = "<home>" ^ ":mosml:src:"
in
  chDir base; chDir "::";
  link "testtop.image"
       (true,true) (* -g -noheader *)
       "none" (base ^ "mosmllib") [(base ^ "compiler"),(base ^ "toolssrc")]

       ["List.uo", "Char.uo", "Strbase.uo", "String.uo", "BasicIO.uo",
        "Vector.uo", "Misc.uo", "Array.uo", "StringCvt.uo", "Word8.uo",
        "Word8Vector.uo", "CharVector.uo", "Word8Array.uo", "CharArray.uo",
        "Obj.uo", "Nonstdio.uo", "Substring.uo", "Path.uo", "Time.uo",
        "OS.uo", "FileSys.uo", "Lexing.uo", "Parsing.uo", "Miscsys.uo",
        "Printexc.uo", "Filename.uo", "Fnlib.uo", "Sort.uo", "Stack.uo",
        "Arg.uo", "Hasht.uo", "Memory.uo", "Config.uo", "Mixture.uo",
        "Const.uo", "Smlexc.uo", "Prim.uo", "Instruct.uo", "Lambda.uo",
        "Smlprim.uo", "Globals.uo", "Location.uo", "Units.uo", "Types.uo",
        "Smlperv.uo", "Asynt.uo", "Asyntfn.uo", "Parser.uo", "Lexer.uo",
        "Primdec.uo", "Infixst.uo", "Ovlres.uo", "Synchk.uo", "Infixres.uo",
        "Elab.uo", "Tr_env.uo", "Pr_lam.uo", "Match.uo", "Front.uo",
        "Back.uo", "Pr_zam.uo", "Opcodes.uo", "Prim_opc.uo", "Buffcode.uo",
        "Labels.uo", "Code_dec.uo", "Reloc.uo", "Emitcode.uo", "Emit_phr.uo",
        "Sigmtch.uo", "Crc.uo", "Compiler.uo", "Predef.uo", "Prim_c.uo",
        "Symtable.uo", "Patch.uo", "Tr_const.uo", "Rtvals.uo", "Load_phr.uo",
        "Exec_phr.uo", "Link.uo", "Deppars.uo", "Deplex.uo",
        "Smltope.uo", "Maine.uo"]
end;

(* another way to build the lexer *)

let val base = "<home>" ^ ":mosml:src:"
in
  chDir base; chDir "::";
  link "mosmllex"
       (true,true) (* -g -noheader *)
       "none" (base ^ "mosmllib") [(base ^ "lex"),(base ^ "compiler")]

       ["List.uo", "Vector.uo", "Array.uo", "Char.uo", "Strbase.uo", 
        "String.uo", "StringCvt.uo", "Word8.uo", "Word8Vector.uo", 
        "Word8Array.uo", "CharVector.uo", "CharArray.uo", "Obj.uo", 
        "BasicIO.uo", "Nonstdio.uo", "Lexing.uo", "Parsing.uo", 
        "Miscsys.uo", "Printexc.uo", "Filename.uo", "Fnlib.uo", 
        "Sort.uo", "Hasht.uo", "Syntax.uo", "Scan_aux.uo", 
        "Gram_aux.uo", "Grammar.uo", "Scanner.uo", "Lexgen.uo", 
        "Output.uo", "Mainlex.uo"]
end;

(* ********************************** *)
