# Unix configuration Makefile for Moscow ML

MOSMLHOME=${HOME}/mosml

CAMLRT=../runtime

MOSMLTOOLS=../tools

MOSMLC=../camlrunm ../mosmlcmp -stdlib ../mosmllib -P none
MOSMLL=../camlrunm ../mosmllnk -stdlib ../mosmllib -P none

MOSMLLEX=../camlrunm ../mosmllex
MOSMLYACC=../mosmlyac/mosmlyac
MOSMLCUT=../camlrunm ../cutdeps 
MOSMLDEP=../camlrunm ../mosmldep

# For Linux and other well-behaved systems, use:
CPP=/lib/cpp -P -traditional -Dunix -Umsdos
STRIP=strip

# For HP-UX, use instead:
# CPP=/lib/cpp -P -Dunix -Umsdos

# For SunOS 5.4 and similar (Solaris 2), use instead:
# CPP=/usr/ccs/lib/cpp -P -Dunix -Umsdos
# STRIP=/usr/ccs/bin/strip

CC=gcc

# BINDIR contains true executable files, such as scripts
# LIBDIR contains linked bytecode files (such as mosmlcmp) 
#                 as well as unlinked bytecode files (library units)

BINDIR=${MOSMLHOME}/bin
LIBDIR=${MOSMLHOME}/lib
TOOLDIR=${MOSMLHOME}/tools

.SUFFIXES :
.SUFFIXES : .sml .sig .ui .uo .mlp .lex .c .o

.sig.ui:
	$(MOSMLC) $(COMPFLAGS) $<

.sml.uo:
	$(MOSMLC) $(COMPFLAGS) $<

.mlp.sml:
	$(CPP) $< > $*.sml

.lex.sml:
	$(MOSMLLEX) $<

.c.o:
	$(CC) -c $(CFLAGS) -o $@ $<
