(* Predefined SML exceptions *)

local
  open Obj Const;
in

(* SML exceptions *)

val predefExceptions = [
  ("Bind",     (({qual="general", id="Bind"},      2), 0)),
  ("Chr",      (({qual="general", id="Chr"},       3), 0)),
  ("Div",      (({qual="general", id="Div"},       4), 0)),
  ("Ln",       (({qual="general", id="Ln"},        5), 0)),
  ("Match",    (({qual="general", id="Match"},     6), 0)),
  ("Ord",      (({qual="general", id="Ord"},       7), 0)),
  ("Sqrt",     (({qual="general", id="Sqrt"},      8), 0)),
  ("Overflow", (({qual="general", id="Overflow"},  9), 0)),
  ("Trig",     (({qual="general", id="Trig"},     10), 0)),
  ("Out_of_memory",
            (({qual="exc",     id="Out_of_memory"}, 1), 0)),
  ("Invalid_argument",
            (({qual="exc",     id="Invalid_argument"}, 2), 1)),
  ("Fail",  (({qual="exc",     id="Failure"},     3), 1)),
  ("Subscript",
            (({qual="exc",     id="Not_found"},   4), 0)),
  ("Size",  (({qual="io",      id="End_of_file"}, 1), 0)),
  ("Io",    (({qual="sys",     id="Sys_error"},   1), 1)),
  ("Interrupt",
            (({qual="sys",    id="Break"},     2), 0)),
  ("Graphic_failure",
            (({qual="graphics", id="Graphic_failure"}, 1), 1))
];


val exnTag = obj_tag(repr (let exception DUMMY in DUMMY end));
val exnTagName   = ({qual="General", id="(Exception)"}, 0);
val bindTagName  = ({qual="General", id="Bind"}, 0);
val matchTagName = ({qual="General", id="Match"}, 0);

end;
